// Analog 0 for voltmeter

int calibrate(byte min_pwm, byte max_pwm, int desired_mv) {
  Serial.print("Calibration for ");
  Serial.print(desired_mv);
  Serial.print("mv = ");
  read_voltage(128);
  delay(1000);
  int m = calibrate_b(min_pwm, max_pwm, desired_mv);
  Serial.println(m);
  return m;
}

int calibrate_b(byte min_pwm, byte max_pwm, int desired_mv) {
  int m;
  while(min_pwm<=max_pwm) {
    m=(min_pwm+max_pwm)/2;
    int mv = read_voltage(m);
    if (desired_mv==mv) {
      break;
    } else if(desired_mv<mv) {
      max_pwm=m-1;
    } else {
      min_pwm=m+1;
    }
  }
  return m;
}

// start with initial voltage and delay(1500)
// when used to read a slowly-changing voltage per-step delay(250) is ok.
// with sudden jumps from previous call, use delay(1500)
unsigned int read_voltage(byte pwm) {
  analogWrite(PWM, pwm);
  delay(250);
  long avg = 0;
  analogRead(DVM);
  for (byte i = 0; i < 10; i++) {
    avg += analogRead(DVM);
  }
  return (avg*(VCC_MV/10))/1024L;
}

void test_voltage(byte pwm) {
  Serial.print(pwm);
  Serial.print("=");
  unsigned int v = read_voltage(pwm);
  Serial.print(v);
  Serial.println("mv ");
}


